// MakeTestFileDlg.cpp : Implementierungsdatei
//

#include "stdafx.h"
#include "MakeTestFile.h"
#include "MakeTestFileDlg.h"
#include ".\maketestfiledlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CMakeTestFileDlg Dialogfeld



CMakeTestFileDlg::CMakeTestFileDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMakeTestFileDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMakeTestFileDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_EDIT1, filename);
	DDX_Control(pDX, IDC_CHECK5, uncompressed);
	DDX_Control(pDX, IDC_CHECK2, text);
	DDX_Control(pDX, IDC_CHECK3, cutter);
	DDX_Control(pDX, IDC_CHECK6, uncompIF);
	DDX_Control(pDX, IDC_CHECK1, tiff);
	DDX_Control(pDX, IDC_CHECK4, runLength);
}

BEGIN_MESSAGE_MAP(CMakeTestFileDlg, CDialog)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BUTTON1, OnBnClickedButton1)
	ON_BN_CLICKED(IDOK, OnMake)
	ON_BN_CLICKED(IDC_BUTTON2, OnPrintButtonClicked)
	ON_BN_CLICKED(IDC_BUTTON3, OnReadPrinterButton)
END_MESSAGE_MAP()


// CMakeTestFileDlg Meldungshandler

BOOL CMakeTestFileDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Symbol fr dieses Dialogfeld festlegen. Wird automatisch erledigt
	//  wenn das Hauptfenster der Anwendung kein Dialogfeld ist
	SetIcon(m_hIcon, TRUE);			// Groes Symbol verwenden
	SetIcon(m_hIcon, FALSE);		// Kleines Symbol verwenden

	// TODO: Hier zustzliche Initialisierung einfgen
	
	return TRUE;  // Geben Sie TRUE zurck, auer ein Steuerelement soll den Fokus erhalten
}

// Wenn Sie dem Dialogfeld eine Schaltflche "Minimieren" hinzufgen, bentigen Sie 
//  den nachstehenden Code, um das Symbol zu zeichnen. Fr MFC-Anwendungen, die das 
//  Dokument/Ansicht-Modell verwenden, wird dies automatisch ausgefhrt.

void CMakeTestFileDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // Gertekontext zum Zeichnen

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Symbol in Clientrechteck zentrieren
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Symbol zeichnen
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// Die System ruft diese Funktion auf, um den Cursor abzufragen, der angezeigt wird, whrend der Benutzer
//  das minimierte Fenster mit der Maus zieht.
HCURSOR CMakeTestFileDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CMakeTestFileDlg::OnBnClickedButton1()
{
	CFileDialog    dlg(TRUE,NULL,NULL,NULL);
	CString string;
	bool eof=false;
	bool printnow;

    if(IDOK == dlg.DoModal())
    {
        strFullPath=dlg.GetPathName();        
		filename.SetWindowText(dlg.GetFileName());
    }
}

void CMakeTestFileDlg::OnBnClickedCheck1()
{

	
}

void CMakeTestFileDlg::createBuffer()
{
	int pos,i;

	strcpy(buffer,"\n\n\n\nGebe out\n\n\0");
	pos=14;

	if(uncompressed.GetCheck())
	{
		// Gebe Schriftzug
		buffer[pos++]=13;
		buffer[pos++]=71;
		buffer[pos++]=69;
		buffer[pos++]=66;
		buffer[pos++]=69;
		buffer[pos++]=13;

		// <ESC>m0
		buffer[pos++]=27;
		buffer[pos++]=109;
		buffer[pos++]=0;

		// Graphikdaten
		buffer[pos++]=27;
		buffer[pos++]=103;
		buffer[pos++]=72;
		for(i=0;i<72;i++)
			buffer[pos+i]=255;
		pos+=72;

		buffer[pos++]=27;
		buffer[pos++]=103;
		buffer[pos++]=1;
		buffer[pos++]=0;

		buffer[pos++]=27;
		buffer[pos++]=103;
		buffer[pos++]=72;
		for(i=0;i<72;i++)
			buffer[pos+i]=255;
		pos+=72;

		buffer[pos++]=27;
		buffer[pos++]=103;
		buffer[pos++]=1;
		buffer[pos++]=0;

		buffer[pos++]=27;
		buffer[pos++]=103;
		buffer[pos++]=72;
		for(i=0;i<72;i++)
			buffer[pos+i]=255;
		pos+=72;

		buffer[pos++]=27;
		buffer[pos++]=103;
		buffer[pos++]=1;
		buffer[pos++]=0;

		buffer[pos++]=27;
		buffer[pos++]=103;
		buffer[pos++]=72;
		for(i=0;i<72;i++)
			buffer[pos+i]=255;
		pos+=72;

		buffer[pos++]=27;
		buffer[pos++]=103;
		buffer[pos++]=1;
		buffer[pos++]=0;

		buffer[pos++]=27;
		buffer[pos++]=103;
		buffer[pos++]=72;
		for(i=0;i<72;i++)
			buffer[pos+i]=255;
		pos+=72;
	}

	// IF COM
	if(uncompIF.GetCheck())
	{
		// IF Schriftzug
		buffer[pos++]=13;
		buffer[pos++]=73;
		buffer[pos++]=70;
		buffer[pos++]=13;

		// Graphikdaten
		buffer[pos++]=31;
		for(i=0;i<72;i++)
			buffer[pos+i]=255;
		pos+=72;

		buffer[pos++]=31;
		for(i=0;i<72;i++)
			buffer[pos+i]=0;
		pos+=72;

		buffer[pos++]=31;
		for(i=0;i<72;i++)
			buffer[pos+i]=255;
		pos+=72;

		buffer[pos++]=31;
		for(i=0;i<72;i++)
			buffer[pos+i]=0;
		pos+=72;

		buffer[pos++]=31;
		for(i=0;i<72;i++)
			buffer[pos+i]=255;
		pos+=72;

		buffer[pos++]=31;
		for(i=0;i<72;i++)
			buffer[pos+i]=0;
		pos+=72;

		buffer[pos++]=31;
		for(i=0;i<72;i++)
			buffer[pos+i]=255;
		pos+=72;

		buffer[pos++]=31;
		for(i=0;i<72;i++)
			buffer[pos+i]=0;
		pos+=72;

		buffer[pos++]=31;
		for(i=0;i<72;i++)
			buffer[pos+i]=255;
		pos+=72;

		buffer[pos++]=31;
		for(i=0;i<72;i++)
			buffer[pos+i]=0;
		pos+=72;

		buffer[pos++]=31;
		for(i=0;i<72;i++)
			buffer[pos+i]=255;
		pos+=72;
	}

	if(tiff.GetCheck())
	{
		// Tiff Schriftzug
		buffer[pos++]=13;
		buffer[pos++]=84;
		buffer[pos++]=105;
		buffer[pos++]=102;
		buffer[pos++]=102;
		buffer[pos++]=13;

		// <ESC>m2
		buffer[pos++]=27;
		buffer[pos++]=109;
		buffer[pos++]=2;

		// 1.Line: Graphikdateneinstellung: <ESC>g2
		buffer[pos++]=27;
		buffer[pos++]=103;
		buffer[pos++]=2;

		// Daten
		buffer[pos++]=184;
		buffer[pos++]=255;

		// 2.Line: Graphikdateneinstellung: <ESC>g2
		buffer[pos++]=27;
		buffer[pos++]=103;
		buffer[pos++]=2;
		
		// Daten
		buffer[pos++]=184;
		buffer[pos++]=0;

		// 3.Line: Graphikdateneinstellung: <ESC>g2
		buffer[pos++]=27;
		buffer[pos++]=103;
		buffer[pos++]=2;

		// Daten
		buffer[pos++]=184;
		buffer[pos++]=255;

		// 4.Line: Graphikdateneinstellung: <ESC>g2
		buffer[pos++]=27;
		buffer[pos++]=103;
		buffer[pos++]=2;

		// Daten
		buffer[pos++]=184;
		buffer[pos++]=0;

		// 5.Line: Graphikdateneinstellung: <ESC>g2
		buffer[pos++]=27;
		buffer[pos++]=103;
		buffer[pos++]=2;

		// Daten
		buffer[pos++]=184;
		buffer[pos++]=255;

		// 6.Line: Graphikdateneinstellung: <ESC>g2
		buffer[pos++]=27;
		buffer[pos++]=103;
		buffer[pos++]=2;
		
		// Daten
		buffer[pos++]=184;
		buffer[pos++]=0;

		// 7.Line: Graphikdateneinstellung: <ESC>g2
		buffer[pos++]=27;
		buffer[pos++]=103;
		buffer[pos++]=2;

		// Daten
		buffer[pos++]=184;
		buffer[pos++]=255;

		// 8.Line: Graphikdateneinstellung: <ESC>g2
		buffer[pos++]=27;
		buffer[pos++]=103;
		buffer[pos++]=2;
		
		// Daten
		buffer[pos++]=184;
		buffer[pos++]=0;

		// 9.Line: Graphikdateneinstellung: <ESC>g2
		buffer[pos++]=27;
		buffer[pos++]=103;
		buffer[pos++]=2;

		// Daten
		buffer[pos++]=184;
		buffer[pos++]=255;
	}

	if(runLength.GetCheck())
	{
		// Run length Schriftzug
		buffer[pos++]=13;
		buffer[pos++]=82;
		buffer[pos++]=117;
		buffer[pos++]=110;
		buffer[pos++]=32;
		buffer[pos++]=108;
		buffer[pos++]=101;
		buffer[pos++]=110;
		buffer[pos++]=103;
		buffer[pos++]=116;
		buffer[pos++]=104;
		buffer[pos++]=13;

		// <ESC>m1
		buffer[pos++]=27;
		buffer[pos++]=109;
		buffer[pos++]=1;

		// 1.Line: Graphikdateneinstellung: <ESC>g2
		buffer[pos++]=27;
		buffer[pos++]=103;
		buffer[pos++]=2;

		// Daten
		buffer[pos++]=72;
		buffer[pos++]=255;

		// 2.Line: Graphikdateneinstellung: <ESC>g2
		buffer[pos++]=27;
		buffer[pos++]=103;
		buffer[pos++]=2;

		// Daten
		buffer[pos++]=72;
		buffer[pos++]=0;

		// 3.Line: Graphikdateneinstellung: <ESC>g2
		buffer[pos++]=27;
		buffer[pos++]=103;
		buffer[pos++]=2;

		// Daten
		buffer[pos++]=72;
		buffer[pos++]=255;

		// 4.Line: Graphikdateneinstellung: <ESC>g2
		buffer[pos++]=27;
		buffer[pos++]=103;
		buffer[pos++]=2;

		// Daten
		buffer[pos++]=72;
		buffer[pos++]=0;

		// 5.Line: Graphikdateneinstellung: <ESC>g2
		buffer[pos++]=27;
		buffer[pos++]=103;
		buffer[pos++]=2;

		// Daten
		buffer[pos++]=72;
		buffer[pos++]=255;

		// 6.Line: Graphikdateneinstellung: <ESC>g2
		buffer[pos++]=27;
		buffer[pos++]=103;
		buffer[pos++]=2;

		// Daten
		buffer[pos++]=72;
		buffer[pos++]=0;

		// 7.Line: Graphikdateneinstellung: <ESC>g2
		buffer[pos++]=27;
		buffer[pos++]=103;
		buffer[pos++]=2;

		// Daten
		buffer[pos++]=72;
		buffer[pos++]=255;

		// 8.Line: Graphikdateneinstellung: <ESC>g2
		buffer[pos++]=27;
		buffer[pos++]=103;
		buffer[pos++]=2;

		// Daten
		buffer[pos++]=72;
		buffer[pos++]=0;

		// 9.Line: Graphikdateneinstellung: <ESC>g2
		buffer[pos++]=27;
		buffer[pos++]=103;
		buffer[pos++]=2;

		// Daten
		buffer[pos++]=72;
		buffer[pos++]=255;
	}

	if(text.GetCheck())
	{
		buffer[pos++]=13;
		buffer[pos++]=13;
		for(i=0;i<222;i++)
			buffer[pos+i]=i+33;
		pos+=222;
	}

	if(cutter.GetCheck())
	{
		buffer[pos++]=13;
		buffer[pos++]=13;
		buffer[pos++]=13;
		buffer[pos++]=27;
		buffer[pos++]=67;
		buffer[pos++]=0;
		buffer[pos++]=13;
	}

	numberOfBytes=pos;
}

void CMakeTestFileDlg::OnMake()
{
	CFile file;

	createBuffer();
	
	if(file.Open(strFullPath,CFile::modeCreate|CFile::modeWrite))
	{
		file.Write(buffer,numberOfBytes);
		file.Close();
	}
	else
		MessageBox("Can not open file!");
}

bool CMakeTestFileDlg::openPort()
{
	int i;
	DCB PortDCB;
	CString port;
	bool bResult;
	DWORD baudrate;
	

	// Open port to set timeouts / read / write
	hPort = CreateFile ("COM1:",						// Portname
						GENERIC_READ | GENERIC_WRITE,	// Access (write) mode
						0,								// Share mode
						NULL,							// Pointer to the security attribute
						OPEN_EXISTING,					// How to open the serial port
						0,								// Port attributes
						0);								// Handle to port with attribute
														// to copy

	if(hPort)
	{
		// Set timeout
		LPCOMMTIMEOUTS lpCommTimeouts = NULL; // Timeout structure.
		DWORD ReadIntervalTimeout = 100;
		DWORD ReadTotalTimeoutMultiplier = 0;
		DWORD ReadTotalTimeoutConstant = 1000;
		DWORD WriteTotalTimeoutMultiplier = 10;
		DWORD WriteTotalTimeoutConstant = 100;
		lpCommTimeouts = new COMMTIMEOUTS;
		if(lpCommTimeouts) 
		{ 
			lpCommTimeouts->ReadIntervalTimeout = ReadIntervalTimeout;
			lpCommTimeouts->ReadTotalTimeoutMultiplier = ReadTotalTimeoutMultiplier; 
			lpCommTimeouts->ReadTotalTimeoutConstant = ReadTotalTimeoutConstant;
			lpCommTimeouts->WriteTotalTimeoutMultiplier = WriteTotalTimeoutMultiplier;
			lpCommTimeouts->WriteTotalTimeoutConstant = WriteTotalTimeoutConstant;

			if(SetCommTimeouts( hPort, lpCommTimeouts ))
			{
				delete lpCommTimeouts;

				// Initialize the DCBlength member. 
				PortDCB.DCBlength = sizeof (DCB); 
				
				// Get the default port setting information.
				GetCommState (hPort, &PortDCB);
				
				// Change the DCB structure settings.
				PortDCB.BaudRate = 115200;					// Current baud 
				PortDCB.fBinary = TRUE;						// Binary mode; no EOF check 
				PortDCB.fParity = TRUE;						// Enable parity checking 
				PortDCB.fOutxCtsFlow = true;				// No CTS output flow control 
				PortDCB.fOutxDsrFlow = false;				// No DSR output flow control 
				PortDCB.fDtrControl = DTR_CONTROL_ENABLE;	// DTR flow control type 
				PortDCB.fDsrSensitivity = false;			// SR sensitivity 
				PortDCB.fTXContinueOnXoff = false;			// XOFF continues Tx 
				PortDCB.fOutX = false;						// No XON/XOFF out flow control 
				PortDCB.fInX = false;						// No XON/XOFF in flow control 
				PortDCB.fErrorChar = FALSE;					// Disable error replacement 
				PortDCB.fNull = FALSE;						// Disable null stripping 
				PortDCB.fRtsControl = RTS_CONTROL_HANDSHAKE;// RTS flow control 
				PortDCB.fAbortOnError = FALSE;				// Do not abort reads/writes on error
				PortDCB.ByteSize = 8;						// Number of bits/byte, 4-8 
				PortDCB.Parity = 0;							// 0-4=no,odd,even,mark,space 
				PortDCB.StopBits = 0;						// 0,1,2 = 1, 1.5, 2 

				// Configure the port according to the specifications of the DCB structure.
				if (SetCommState (hPort, &PortDCB))
				{
					return true;
				}
				else
				{
					MessageBox("Can not set correct baudrate!",MB_OK);
				}
			}
			else
			{
				MessageBox("Failed to set new timeouts!",MB_OK);
				bResult = GetLastError( );
			}
		}
		else
		{
			MessageBox("Failed to allocate memory for timeout struct!",MB_OK);
			bResult = GetLastError( ) ;
		}
		CloseHandle(hPort);
	}
	else
	{
		MessageBox("Can not open port!",MB_OK);
	}
	return bResult;
}

bool CMakeTestFileDlg::closePort()
{
	if(hPort)
	{
		if(CloseHandle(hPort))
			return true;
		else
			return false;
	}

	return false;
}

void CMakeTestFileDlg::OnPrintButtonClicked()
{
	DWORD nRead, dwNumBytesWritten, filesize, totalBytes;
	
	createBuffer();

	if(openPort())
	{
		// Write buffer to printer
		WriteFile (hPort,	// Port handle
			buffer,					// Pointer to the data to write 
			numberOfBytes,			// Number of bytes to write
			&dwNumBytesWritten,		// Pointer to the number of bytes written
			NULL					
		);

		closePort();
	}	
}


void CMakeTestFileDlg::OnReadPrinterButton()
{
	bool bResult,ready=false;
	CString output,out;
	char inBuffer[1024];
	int i;
	DWORD nRead=0;
	
	output="Output: ";

	if(openPort())
	{
		CTime t=CTime::GetCurrentTime();

		while(!ready && CTime::GetCurrentTime()<t+CTimeSpan(0,0,0,10)){	
			bResult = ReadFile(hPort, &inBuffer, 1, &nRead, NULL);
			
			if(!bResult)
			{
				MessageBox("Error! Can't read printer!",MB_OK);
				ready=true;
			}

			if(nRead>0)
			{
				for(i=0;i<nRead;i++)
					output.Format("%s %c",output,inBuffer[i]);

				MessageBox(output,MB_OK);
				ready=true;
			}
			Sleep(100);
		}

		closePort();
	}
}
